#include <stdio.h>
#include <stdlib.h>

struct prenotazione {
       long matricola;
       int materia,corso;
       char giorno[12];
       };
struct atomo {
       struct prenotazione dato;
  struct atomo *next;
};


struct esame {
       long matricola;
       int materia,voto;
       char giorno[12];
       };
void ins_prenotazione(struct atomo *L[4])
{
     struct prenotazione p;
     struct atomo *a;
     
     a=malloc(sizeof(struct atomo));
     if(a==NULL)
      return;
     
     printf("Matricola: ");
     scanf("%ld",&p.matricola);
     printf("Codice materia (0..9): ");
     scanf("%d",&p.materia);
     printf("Giorno: ");
     scanf("%s",p.giorno);
     printf("Corso di laurea (0..3) ");
     scanf("%d",&p.corso);
     
     a->dato=p;
     a->next=L[p.corso];
     L[p.corso]=a;
     
}
void vis_prenotazione(struct prenotazione p)
{
     printf("Matricola: %ld\n",p.matricola);
     printf("Materia: %d\n\n",p.materia);
}

void da_testa(struct atomo **testa)
{
     struct atomo *a;
     
     a=*testa;
     *testa=a->next;
     free(a);
}
     
void elimina_prenotazione(struct atomo *L[4])
{
     long matricola;
     int c;
     
     struct atomo *l1,*l2;
     
     printf("Matricola: ");
     scanf("%ld",&matricola);
     printf("Corso (0..3) ");
     scanf("%d",&c);
     
     if(L[c]==NULL)
       {
         printf("Lista vuota\n");
         return;
       }
     if(matricola==L[c]->dato.matricola)
       { vis_prenotazione(L[c]->dato);
         da_testa(&L[c]);
         return;
       }
     l1=L[c]->next;
     l2=L[c];
     while(l1!=NULL)
       if(matricola==l1->dato.matricola)
         { vis_prenotazione(l1->dato);
           l2->next=l1->next;
           free(l1);
           return;
         }
       else {l1=l1->next;
             l2=l2->next;
             }
     
     printf("\nElemento non trovato\n");
}     
           
void leggi_esame( struct esame *e)
{
     printf("Matricola ");
     scanf("%ld",&e->matricola);
     printf("Codice materia (0..9) ");
     scanf("%d",&e->materia);
     printf("Voto ");
     scanf("%d",&e->voto);
     printf("Giorno");
     scanf("%s",e->giorno);
}

void ins_esame (struct esame **R,int *n, struct esame e)         
{
     struct esame *a;
     
     a=realloc(*R,(*n+1)*sizeof(struct esame));
     if(a==NULL)
       return;
    *R=a;
    (*R)[*n]=e;
    (*n)++;
}

void vis_esami(struct esame *R, int n)
{
     int i;
     
     for(i=0;i<n;i++)
      { printf("Matricola: %ld\n",R[i].matricola);
        printf("Voto: %d\n\n",R[i].voto);
      }
}         
       
void salva(struct esame *T[10], int *N)
{
     FILE *pf;
     int i,j;
     
     pf=fopen("esami.dat","w");
     if(pf) {
         for(i=0;i<10;i++)
           for(j=0;j<N[i];j++)
              fwrite(&T[i][j],sizeof(struct esame),1,pf);
         fclose(pf);
     }
     else printf("Errore\n");
}

void leggi_file(struct esame *T[10], int *N)
{
     FILE *pf;
     struct esame e;
     int i;
     
     pf=fopen("esami.dat","r");
     if(pf) {
         while (fread(&e,sizeof(struct esame),1,pf)>0)
          {    i=e.materia;
               ins_esame(&T[i],&N[i],e);
          }
         fclose(pf);
     }
     else printf("Errore in lettura\n");
}    
     
     
     

main() {

struct atomo *L[4];

struct esame *TB[10];
int N[10];

int scelta,i;
struct esame e;

 /*inizializzazione*/
   for(i=0;i<4;i++)
     L[i]=NULL;
     
   for(i=0;i<10;i++)
     {TB[i]=NULL;
      N[i]=0;
      }
      
   do {
     printf("\nScegli\n");
     printf("1) Ins pprenotazione\n");
     printf("2) Elimina prenotazione\n");
     printf("3) Ins. esame\n");
     printf("4) Vis esami\n");
     printf("5) Salva esami\n");
     printf("6) Lettura da file\n");
     printf("0) Fine\n");
     scanf("%d",&scelta);
     switch(scelta) {
       case 1:  ins_prenotazione(L);
                break;
       case 2:  elimina_prenotazione(L);
                break;
      case 3:  leggi_esame(&e);
                i=e.materia;
                ins_esame(&TB[i],&N[i],e);
                break;
       case 4:  printf("Codice materia (0..9): ");
                scanf("%d",&i);
                vis_esami(TB[i],N[i]);
                break;
      case 5:  salva(TB,N);
                break;
       case 6:  leggi_file(TB,N);
                break;
       default:;
       }
     } while(scelta!=0);
     
   /* liberazione della memoria */
    for(i=0;i<10;i++)
       free(TB[i]);
       
    for(i=0;i<4;i++)
      while(L[i]!=NULL)
         da_testa(&L[i]);
         
}
                 

